<?xml version="1.0" encoding="iso-8859-1" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en">
<head>
	<title>Git - Fast Version Control System</title>
	<meta name="description" content="Home of the Git Version Control System and Friends" />
	<meta name="author" content="Petr Baudis" />
	<meta http-equiv="reply-to" content="pasky@suse.cz" />
	<meta http-equiv="content-language" content="en" />
	<meta http-equiv="content-type" content="text/html; charset=iso-8859-1" />
	<link type="text/css" rel="stylesheet" media="screen" href="stylesheets/screen.css" />
	<link type="text/css" title="Default" rel="stylesheet" media="screen" href="stylesheets/screen-default.css" />
	<link type="text/css" title="Gitweb Gray" rel="alternate stylesheet" media="screen" href="stylesheets/screen-gitweb-gray.css" />
	<link type="text/css" title="Blue" rel="alternate stylesheet" media="screen" href="stylesheets/screen-blue.css" />
	<link type="text/css" title="Green" rel="alternate stylesheet" media="screen" href="stylesheets/screen-green.css" />
	<link rel="alternate" title="RSS - All News" href="http://gitrss.q42.co.uk/all.rss" type="application/rss+xml" />
	<link rel="alternate" title="RSS - Announcements" href="http://gitrss.q42.co.uk/announce.rss" type="application/rss+xml" />
	<link rel="icon" href="favicon.png" type="image/png" />
</head>

<body>

<table border="1" summary="Navigation links" class="header" width="100%"><tr><td>
	<a href="index.html" id="top"><img src="git-logo.png" width="72" height="27" alt="Git"
		style="border-width:0px;"/></a>
	<span class="hide">:</span>
	<span class="menu">
		<a href="index.html">Home</a> |
		<a href="http://www.kernel.org/pub/software/scm/git/docs/">Documentation</a> |
		<a href="http://git.or.cz/gitwiki/GitFaq">FAQ</a> |
		<a href="http://git.or.cz/gitwiki">Wiki</a> |
		<a href="http://www.kernel.org/pub/software/scm/git/">Download Site</a> |
		<a href="http://git.kernel.org/git/?p=git/git.git;a=summary">Git's Gitweb</a>
	</span>
</td></tr></table>

<h1>Git&ensp;&ndash;&ensp;Fast Version Control System</h1>

<p>Git is an open source version control system
designed to handle very large projects with speed and efficiency,
but just as well suited for small personal repositories;
it is especially popular in the open source community,
serving as a development platform for projects like
the <em>Linux Kernel</em>, <em>Ruby on Rails</em>, <em>WINE</em> or <em>X.org</em>.</p>

<p>Git falls in the category of distributed source code management tools,
similar to e.g. <em>Mercurial</em> or <em>Bazaar</em>.
Every Git working directory is a full-fledged repository with complete history
and full revision tracking capabilities, not dependent on network access
or a central server. Still, Git stays extremely fast and space efficient.</p>

<p>Git is an <a href="http://www.opensource.org/">Open Source</a> project covered by
the <a href="http://www.gnu.org/licenses/gpl2.txt">GNU General Public License v2</a>.
It was originally written by Linus Torvalds and is currently maintained by
Junio C Hamano.</p>




<div style="float: right"><table class="releases">
	<tr class="odd" align="center"><td colspan="3"><b>Download GIT source package</b> <!--@DATE@-->[2009-06-22]</td></tr>
	<tr align="center"><td colspan="3">The latest stable Git release is <b><!--@VNUM@-->v1.6.3.3</b>:</td></tr>
	<tr align="center"><td colspan="3">
		<table><tr><td>
		<!--@TARLINK@--><a href="http://kernel.org/pub/software/scm/git/git-1.6.3.3.tar.bz2">tar.bz2</a>
		<!--@TARLINK@--><a href="http://kernel.org/pub/software/scm/git/git-1.6.3.3.tar.bz2.sign">(sign)</a>
		</td><td>
		<!--@TARLINK@--><a href="http://kernel.org/pub/software/scm/git/git-1.6.3.3.tar.gz">tar.gz</a>
		<!--@TARLINK@--><a href="http://kernel.org/pub/software/scm/git/git-1.6.3.3.tar.gz.sign">(sign)</a>
		</td></tr></table>
	</td></tr>
	<tr class="odd" align="center">
		<td><!--@NOTESLINK@--><a href="http://www.kernel.org/pub/software/scm/git/docs/RelNotes-1.6.3.3.txt">Release notes</a></td>
		<td><a href="http://kernel.org/pub/software/scm/git/">More versions</a></td>
		<td><a href="http://repo.or.cz/w/git.git/">Browse history/code</a></td>
        </tr>
</table></div>


<hr />

<ul class="toc">
	<li><a href="#about">About Git</a></li>
	<li><a href="#documentation">Documentation</a></li>
	<li><a href="#download">Download</a></li>
	<li><a href="#tools">Related Tools</a></li>
	<li><a href="#community">Community and Development</a></li>
</ul>


<hr />

<h2 id="about">About Git</h2>

<div style="float: right">
<table class="releases">
	<tr><th><a href="course/index.html">Git Crash Courses</a></th></tr>
	<tr><td align="center">
	<a href="http://www.kernel.org/pub/software/scm/git/docs/gittutorial.html">Git for everyone</a>
	<!--
	<br /><a href="course/new.html">New to revision control?</a>
	-->
	<br /><a href="course/stgit.html">Maintaining external patches</a>
	<br /><a href="course/svn.html">Git for SVN users</a>
	<!-- <br /><em>More to come soon...</em> -->
	</td></tr>
</table>
</div>

<p>Git is distributed version control system focused on
speed, effectivity and real-world usability on large projects.
Its highlights include:</p>

<!-- Heavily inspired by Wikipedia -->

<ul>

<li>
<b>Distributed development.</b>
Like most other modern version control systems, Git gives each developer
a local copy of the entire development history,
and changes are copied from one such repository to another.
These changes are imported as additional development branches,
and can be merged in the same way as a locally developed branch.
Repositories can be easily accessed via the efficient Git protocol
(optionally wrapped in ssh for authentication and security)
or simply using HTTP - you can publish your repository anywhere
without <em>any</em> special webserver configuration required.
</li>

<li>
<b>Strong support for non-linear development.</b>
Git supports rapid and convenient branching and merging,
and includes powerful tools for visualizing
and navigating a non-linear development history.
</li>

<li>
<b>Efficient handling of large projects.</b>
Git is very fast and scales well
even when working with large projects and long histories.
It is commonly an order of magnitude faster
than most other version control systems,
and several orders of magnitude faster on some operations.
It also uses an extremely efficient packed format
for long-term revision storage
that currently tops any other open source version control system.
</li>

<li>
<b>Cryptographic authentication of history.</b>
The Git history is stored in such a way
that the name of a particular revision (a "commit" in Git terms)
depends upon the complete development history leading up to that commit.
Once it is published, it is not possible to change the old versions
without it being noticed. Also, tags can be cryptographically signed.
</li>

<li>
<b>Toolkit design.</b>
Following the Unix tradition,
Git is a collection of many small tools written in C,
and a number of scripts that provide convenient wrappers.
Git provides tools for both convenient human usage and easy
scripting to perform new clever operations.
</li>

</ul>

<p>Besides providing a version control system,
the Git project provides a generic low-level toolkit
for tree history storage and directory content management.
Traditionally, the toolkit is called the <em>plumbing</em>.
Aside the user interface coming with Git itself,
several other projects (so-called <em>porcelains</em>)
offer compatible version control interfaces - see the
<a href="#tools">related tools</a> list.</p>


<hr />

<h2 id="documentation">Documentation</h2>

<p>You can find all the documentation bundled with the Git source code
in the <a href="http://www.kernel.org/pub/software/scm/git/docs/"><code>Documentation/</code></a> subdirectory
(the web version corresponds to the latest Git development version).</p>

<p>See <a href="http://www.kernel.org/pub/software/scm/git/docs/gittutorial.html">the tutorial</a> to get started,
then see <a href="http://www.kernel.org/pub/software/scm/git/docs/everyday.html">Everyday Git</a> for a useful minimum set of commands.
Especially users migrating from other systems might appreciate the <a href="course/">Crash Courses</a>.
See <a href="http://www.kernel.org/pub/software/scm/git/docs/user-manual.html">Git User's Manual</a> for a more in-depth introduction.
You can find links to more useful documentation at the
<a href="http://git.or.cz/gitwiki/GitDocumentation">GitDocumentation</a> wiki page.</p>

<p>For a large and continuously growing resource of information
about Git, you can refer to the <a href="http://git.or.cz/gitwiki">Git Wiki</a>
- you are welcome to contribute!</p>


<hr />

<h2 id="download">Download</h2>

<p>The general download location for Git releases is
<strong><a href="http://www.kernel.org/pub/software/scm/git/">http://www.kernel.org/pub/software/scm/git/</a></strong>.
You can also use one of many <a href="http://www.kernel.org/mirrors/">kernel.org mirrors</a>.</p>

<h3>Git by Git</h3>

<p>If you already have Git installed, you can get the latest
development version via Git itself:</p>
<pre>git clone git://git.kernel.org/pub/scm/git/git.git</pre>

<p>If you have problems connecting (Git uses port 9418),
you can try to access the repository over the HTTP protocol:</p>
<pre>git clone http://www.kernel.org/pub/scm/git/git.git</pre>
<p>(this method is considerably slower but works even behind
firewalls and such).</p>

<p>You can also always browse the current contents
of the git repository on web using the kernel.org
<a href="http://kernel.org/git/?p=git/git.git;a=summary">gitweb interface</a>.</p>

<h3>Binaries</h3>

<p>For people who prefer precompiled packages, these are available:</p>

<table class="bugmail">

<tr>
<td colspan="2">RPMs</td>
<td><a href="http://kernel.org/pub/software/scm/git/RPMS/">http://kernel.org/pub/software/scm/git/RPMS/</a></td>
</tr>

<tr class="odd">
<td rowspan="3">Debs</td>
<td>Stable</td>
<td><a href="http://www.backports.org/debian/pool/main/g/git-core/">http://www.backports.org/debian/pool/main/g/git-core/</a></td>
</tr>
<tr>
<td>Testing</td>
<td><a href="http://packages.debian.org/testing/devel/git-core">http://packages.debian.org/testing/devel/git-core</a></td>
</tr>
<tr class="odd">
<td>Unstable</td>
<td><a href="http://packages.debian.org/unstable/devel/git-core">http://packages.debian.org/unstable/devel/git-core</a></td>
</tr>

<tr>
<td rowspan="2">Win</td>
<td><a href="http://www.cygwin.com/">Cygwin</a></td>
<td><a href="http://www.cygwin.com/setup.exe">http://www.cygwin.com/setup.exe</a></td>
</tr>
<tr class="odd">
<td><a href="http://code.google.com/p/msysgit/">msysGit</a></td>
<td><a href="http://code.google.com/p/msysgit/downloads/list">http://code.google.com/p/msysgit/downloads/list</a></td>
</tr>

<tr class="odd">
<td rowspan="2">OS X</td>
</tr>
<tr>
<td>Stable</td>
<td><a href="http://code.google.com/p/git-osx-installer/downloads/list?can=3">http://code.google.com/p/git-osx-installer/downloads/list?can=3</a></td>
</tr>

<tr>
<td rowspan="3">Solaris</td>
</tr>
<tr class="odd">
<td>v8&ndash;10</td>
<td><a href="http://sunfreeware.com/">http://sunfreeware.com/</a></td>
</tr>

</table>

<h3>Development snapshots</h3>

<p>Daily snapshots of the main Git development branch are available at
<a href="http://www.codemonkey.org.uk/projects/git-snapshots/git/"
>http://www.codemonkey.org.uk/projects/git-snapshots/git/</a>
(thanks to Dave Jones).</p>



<hr />

<h2 id="tools">Related Tools</h2>

<p>Git is a true UNIX tool in the sense that it consists of many commands
that do one thing well. It has been designed from the start to be easily
wrapped in other tools and frontends. Currently, there are several
interfaces offering more comfortable Git usage, and also graphical
interfaces for browsing the history and more.</p>

<p>Traditionally, the low-level part of Git is called <em>plumbing</em>
and the interfaces and frontends are called <em>porcelains</em>.
Git itself comes with a default porcelain bundled and that is actually
what you will normally mean when you say you use Git. However, there
are several alternative porcelains which might offer considerably more
user friendly interface or extend Git to perform some specialized tasks.</p>

<p>Below, the most widely used tools are listed. Please refer to
<a href="http://git.or.cz/gitwiki/InterfacesFrontendsAndTools">the corresponding wiki page</a>
for a full list.</p>

<table>
<tr valign="top">

<td>
<h3>User Interface Tools</h3>

<dl>

<dt id="qgit">qgit</dt>
<dd><a href="http://sourceforge.net/projects/qgit">qgit</a> is a QT
GUI for browsing history of Git repositories, similar to <em>gitk</em>
but with more features.</dd>

<dt id="tig">Tig</dt>
<dd><a href="http://jonas.nitro.dk/tig/">tig</a>
is a text-mode interface for Git. It acts as a repository browser
that can also act as a pager for various Git commands
and manage your index (on diff chunk level).</dd>

</dl>
</td>

<td>
<h3>Tools Shipped with Git</h3>

<dl>

<dt id="gitk">gitk</dt>
<dd><a href="http://git.kernel.org/?p=gitk/gitk.git;a=summary">gitk</a>
is the original TCL/TK GUI for browsing history of Git repositories.</dd>

<dt id="git-gui">Git-gui</dt>
<dd><a href="http://www.spearce.org/category/projects/scm/git-gui/">git-gui</a>
is a simple Tk based graphical interface for common Git
operations.</dd>

<dt id="gitweb">gitweb</dt>
<dd>gitweb provides a full-fledged <a href="http://git.kernel.org/">web interface</a>
for Git repositories.</dd>

</dl>
</td>
</tr>

<tr valign="top">
<td>
<h3>Version Control Interface layers</h3>

<dl>

<dt id="stgit">StGIT</dt>
<dd><a href="http://www.procode.org/stgit/">Stacked Git</a> provides
a <em>Quilt</em>-like patch management functionality in the Git environment.
You can easily manage your patches in the scope of Git until they get
merged upstream.</dd>

<dt id="guilt">Guilt</dt>
<dd><a href="http://www.kernel.org/pub/linux/kernel/people/jsipek/guilt/">Guilt</a>
is another patch management tool, closer to the spirit of <em>Quilt</em>
than StGIT.</dd>

<dt id="cogito">Cogito</dt>
<dd><a href="http://git.or.cz/cogito/">Cogito</a>
was a popular version control system on top of Git,
aiming at seamless user interface and ease of use.
It provided much better user interface in the past
but later improvements of Git made it mostly obsolete
and it is not maintained anymore.
Please migrate to Git itself.</dd>

</dl>
</td>

<td>
<h3>Public Hosting</h3>

<p>Several public Git hosting sites are available and open for anyone
to host their pet projects:</p>

<dl>
<dt id="repo">repo.or.cz</dt>
<dd><a href="http://repo.or.cz/">repo.or.cz</a> is the oldest hosting site,
accomodating many hundreds of projects, with open-sourced infrastructure
and aimed at open source software. It provides full push features as well
as simple mirroring mode and gitweb interface with various enhancements.</dd>

<dt id="github">GitHub</dt>
<dd><a href="http://github.com/">GitHub</a> provides both free hosting for
smaller projects and paid options for private hosting and large-sized projects.
It uses a custom web interface including a wiki hosting and puts emphasis
on social networking of project developers.</dd>

<dt id="gitorious">Gitorious</dt>
<dd><a href="http://gitorious.org/">Gitorious</a> is another free hosting
site with a custom web interface, supporting multiple repositories per project,
local installations and with open source code.</dd>

</dl>

<p style="text-align: right; font-size: small"><a href="http://git.or.cz/gitwiki/GitHosting">more sites</a></p>
</td>
</tr>

</table>


<hr />

<h2 id="community">Community and Development</h2>

<p>Git was initially written by Linus Torvalds
with help of a group of hackers 'round the net.
It is currently maintained by
Junio C Hamano.</p>

<p>The user discussion and development of Git and most tools related to Git
takes place on the Git mailing list - everyone is welcome to post
bug reports, feature requests, comments and
<a href="http://repo.or.cz/w/git.git?a=blob_plain;f=Documentation/SubmittingPatches;hb=HEAD">patches</a>
to <a href="mailto:git@vger.kernel.org">git@vger.kernel.org</a>.
To <a href="mailto:majordomo@vger.kernel.org?body=subscribe%20git">subscribe</a>
to the list, send an email with just "subscribe git" in the body to
majordomo@vger.kernel.org.
The mailing list archives are available at
<a href="http://dir.gmane.org/gmane.comp.version-control.git">Gmane</a>
and <a href="http://marc.info/?l=git">MARC</a>.
<a href="http://gitrss.q42.co.uk/">RSS feeds of various news</a>
are also available.</p>

<p>You can also visit the IRC channel dedicated to Git -
meet us at <a href="irc://irc.freenode.net/#git">#git on FreeNode</a>.</p>

<p>This website itself is tracked in Git as well -
you can
<a href="http://repo.or.cz/w/git-homepage.git">browse its development history</a>
or even clone it from http://repo.or.cz/r/git-homepage.git.
The site is covered by GPLv2
and maintained by <a href="mailto:pasky@suse.cz">Petr Baudis</a>
who always takes patches eagerly. ;-)
The web is based on a design by <a href="mailto:fonseca@diku.dk">Jonas Fonseca</a>
for the <a href="http://elinks.cz">ELinks homepage</a>.</p>


<hr />

<div class="footer">
	<span class="menu">
		This page is maintained by Petr Baudis. Please email me
		at <a href="mailto:pasky@suse.cz">pasky@suse.cz</a>
		with patches, suggestions and comments.
	</span>
</div>

</body>
</html>
